Loading...
Searching...
No Matches
irr::scene::SSharedMeshBuffer Struct Reference

Implementation of the IMeshBuffer interface with shared vertex list. More...

`#include <SSharedMeshBuffer.h>`

Inheritance diagram for irr::scene::SSharedMeshBuffer:

## Public Member Functions

| SSharedMeshBuffer ()
| constructor
| SSharedMeshBuffer (core::array< video::S3DVertex > *vertices)
| constructor
virtual void | append (const IMeshBuffer *const other)
| append the meshbuffer to the current buffer
virtual void | append (const void *const vertices, u32 numVertices, const u16 *const indices, u32 numIndices)
| append the vertices and indices to the current buffer
virtual const core::aabbox3d< f32 > & | getBoundingBox () const
| returns an axis aligned bounding box
virtual u32 | getChangedID_Index () const
| Get the currently used ID for identification of changes.
virtual u32 | getChangedID_Vertex () const
| Get the currently used ID for identification of changes.
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Index () const
| get the current hardware mapping hint
virtual E_HARDWARE_MAPPING | getHardwareMappingHint_Vertex () const
| get the current hardware mapping hint
virtual u32 | getIndexCount () const
| returns amount of indices
virtual video::E_INDEX_TYPE | getIndexType () const
| Get type of index data which is stored in this meshbuffer.
virtual u16 * | getIndices ()
| returns pointer to Indices
virtual const u16 * | getIndices () const
| returns pointer to Indices
virtual video::SMaterial & | getMaterial ()
| returns the material of this meshbuffer
virtual const video::SMaterial & | getMaterial () const
| returns the material of this meshbuffer
virtual core::vector3df & | getNormal (u32 i)
| returns normal of vertex i
virtual const core::vector3df & | getNormal (u32 i) const
| returns normal of vertex i
virtual core::vector3df & | getPosition (u32 i)
| returns position of vertex i
virtual const core::vector3df & | getPosition (u32 i) const
| returns position of vertex i
virtual core::vector2df & | getTCoords (u32 i)
| returns texture coord of vertex i
virtual const core::vector2df & | getTCoords (u32 i) const
| returns texture coord of vertex i
virtual u32 | getVertexCount () const
| returns amount of vertices
virtual video::E_VERTEX_TYPE | getVertexType () const
| returns which type of vertex data is stored.
virtual void * | getVertices ()
| returns pointer to vertices
virtual const void * | getVertices () const
| returns pointer to vertices
virtual void | recalculateBoundingBox ()
| recalculates the bounding box. should be called if the mesh changed.
virtual void | setBoundingBox (const core::aabbox3df &box)
| set user axis aligned bounding box
virtual void | setDirty (E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| flags the mesh as changed, reloads hardware buffers
virtual void | setHardwareMappingHint (E_HARDWARE_MAPPING NewMappingHint, E_BUFFER_TYPE buffer=EBT_VERTEX_AND_INDEX)
| set the hardware mapping hint, for driver
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Public Attributes

core::aabbox3df | BoundingBox
| Bounding box.
u32 | ChangedID_Index
| ID used for hardware buffer management.
u32 | ChangedID_Vertex
| ID used for hardware buffer management.
core::array< u16 > | Indices
| Array of Indices.
E_HARDWARE_MAPPING | MappingHintIndex
E_HARDWARE_MAPPING | MappingHintVertex
| hardware mapping hint
video::SMaterial | Material
| Material of this meshBuffer.
core::array< video::S3DVertex > * | Vertices
| Shared Array of vertices.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Implementation of the IMeshBuffer interface with shared vertex list.

Definition at line 16 of file SSharedMeshBuffer.h.

## Constructor & Destructor Documentation

## SSharedMeshBuffer() [1/2]

irr::scene::SSharedMeshBuffer::SSharedMeshBuffer | ( |  | ) |

inline

constructor

Definition at line 19 of file SSharedMeshBuffer.h.

References ChangedID_Index, ChangedID_Vertex, irr::scene::EHM_NEVER, MappingHintIndex, MappingHintVertex, irr::IReferenceCounted::setDebugName(), and Vertices.

## SSharedMeshBuffer() [2/2]

irr::scene::SSharedMeshBuffer::SSharedMeshBuffer | ( | core::array< video::S3DVertex > * | vertices | ) |

inline

constructor

Definition at line 27 of file SSharedMeshBuffer.h.

References irr::IReferenceCounted::setDebugName(), and Vertices.

## Member Function Documentation

## append() [1/2]

virtual void irr::scene::SSharedMeshBuffer::append | ( | const IMeshBuffer *const | other | ) |

inline virtual

append the meshbuffer to the current buffer

Implements irr::scene::IMeshBuffer.

Definition at line 174 of file SSharedMeshBuffer.h.

## append() [2/2]

virtual void irr::scene::SSharedMeshBuffer::append | ( | const void *const | vertices,
|  | u32 | numVertices,
|  | const u16 *const | indices,
|  | u32 | numIndices )

inline virtual

append the vertices and indices to the current buffer

Implements irr::scene::IMeshBuffer.

Definition at line 171 of file SSharedMeshBuffer.h.

## getBoundingBox()

virtual const core::aabbox3d< f32 > & irr::scene::SSharedMeshBuffer::getBoundingBox | ( |  | ) | const

inline virtual

returns an axis aligned bounding box

Implements irr::scene::IMeshBuffer.

Definition at line 98 of file SSharedMeshBuffer.h.

References BoundingBox.

## getChangedID_Index()

virtual u32 irr::scene::SSharedMeshBuffer::getChangedID_Index | ( |  | ) | const

inline virtual

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 212 of file SSharedMeshBuffer.h.

References ChangedID_Index.

## getChangedID_Vertex()

virtual u32 irr::scene::SSharedMeshBuffer::getChangedID_Vertex | ( |  | ) | const

inline virtual

Get the currently used ID for identification of changes.

This shouldn't be used for anything outside the VideoDriver.

Implements irr::scene::IMeshBuffer.

Definition at line 208 of file SSharedMeshBuffer.h.

References ChangedID_Vertex.

## getHardwareMappingHint_Index()

virtual E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::getHardwareMappingHint_Index | ( |  | ) | const

inline virtual

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 183 of file SSharedMeshBuffer.h.

References MappingHintIndex.

## getHardwareMappingHint_Vertex()

virtual E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::getHardwareMappingHint_Vertex | ( |  | ) | const

inline virtual

get the current hardware mapping hint

Implements irr::scene::IMeshBuffer.

Definition at line 177 of file SSharedMeshBuffer.h.

References MappingHintVertex.

## getIndexCount()

virtual u32 irr::scene::SSharedMeshBuffer::getIndexCount | ( |  | ) | const

inline virtual

returns amount of indices

Implements irr::scene::IMeshBuffer.

Definition at line 86 of file SSharedMeshBuffer.h.

References Indices.

## getIndexType()

virtual video::E_INDEX_TYPE irr::scene::SSharedMeshBuffer::getIndexType | ( |  | ) | const

inline virtual

Get type of index data which is stored in this meshbuffer.

Implements irr::scene::IMeshBuffer.

Definition at line 92 of file SSharedMeshBuffer.h.

References irr::video::EIT_16BIT.

## getIndices() [1/2]

virtual u16 * irr::scene::SSharedMeshBuffer::getIndices | ( |  | ) |

inline virtual

returns pointer to Indices

Implements irr::scene::IMeshBuffer.

Definition at line 80 of file SSharedMeshBuffer.h.

References Indices.

## getIndices() [2/2]

virtual const u16 * irr::scene::SSharedMeshBuffer::getIndices | ( |  | ) | const

inline virtual

returns pointer to Indices

Implements irr::scene::IMeshBuffer.

Definition at line 74 of file SSharedMeshBuffer.h.

References Indices.

## getMaterial() [1/2]

virtual video::SMaterial & irr::scene::SSharedMeshBuffer::getMaterial | ( |  | ) |

inline virtual

returns the material of this meshbuffer

Implements irr::scene::IMeshBuffer.

Definition at line 41 of file SSharedMeshBuffer.h.

References Material.

## getMaterial() [2/2]

virtual const video::SMaterial & irr::scene::SSharedMeshBuffer::getMaterial | ( |  | ) | const

inline virtual

returns the material of this meshbuffer

Implements irr::scene::IMeshBuffer.

Definition at line 35 of file SSharedMeshBuffer.h.

References Material.

## getNormal() [1/2]

virtual core::vector3df & irr::scene::SSharedMeshBuffer::getNormal | ( | u32 | i | ) |

inline virtual

returns normal of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 150 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getNormal() [2/2]

virtual const core::vector3df & irr::scene::SSharedMeshBuffer::getNormal | ( | u32 | i | ) | const

inline virtual

returns normal of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 143 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getPosition() [1/2]

virtual core::vector3df & irr::scene::SSharedMeshBuffer::getPosition | ( | u32 | i | ) |

inline virtual

returns position of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 136 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getPosition() [2/2]

virtual const core::vector3df & irr::scene::SSharedMeshBuffer::getPosition | ( | u32 | i | ) | const

inline virtual

returns position of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 129 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getTCoords() [1/2]

virtual core::vector2df & irr::scene::SSharedMeshBuffer::getTCoords | ( | u32 | i | ) |

inline virtual

returns texture coord of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 164 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getTCoords() [2/2]

virtual const core::vector2df & irr::scene::SSharedMeshBuffer::getTCoords | ( | u32 | i | ) | const

inline virtual

returns texture coord of vertex i

Implements irr::scene::IMeshBuffer.

Definition at line 157 of file SSharedMeshBuffer.h.

References _IRR_DEBUG_BREAK_IF, Indices, and Vertices.

## getVertexCount()

virtual u32 irr::scene::SSharedMeshBuffer::getVertexCount | ( |  | ) | const

inline virtual

returns amount of vertices

Implements irr::scene::IMeshBuffer.

Definition at line 65 of file SSharedMeshBuffer.h.

References Vertices.

## getVertexType()

virtual video::E_VERTEX_TYPE irr::scene::SSharedMeshBuffer::getVertexType | ( |  | ) | const

inline virtual

returns which type of vertex data is stored.

Implements irr::scene::IMeshBuffer.

Definition at line 110 of file SSharedMeshBuffer.h.

References irr::video::EVT_STANDARD.

## getVertices() [1/2]

virtual void * irr::scene::SSharedMeshBuffer::getVertices | ( |  | ) |

inline virtual

returns pointer to vertices

Implements irr::scene::IMeshBuffer.

Definition at line 56 of file SSharedMeshBuffer.h.

References Vertices.

## getVertices() [2/2]

virtual const void * irr::scene::SSharedMeshBuffer::getVertices | ( |  | ) | const

inline virtual

returns pointer to vertices

Implements irr::scene::IMeshBuffer.

Definition at line 47 of file SSharedMeshBuffer.h.

References Vertices.

## recalculateBoundingBox()

virtual void irr::scene::SSharedMeshBuffer::recalculateBoundingBox | ( |  | ) |

inline virtual

recalculates the bounding box. should be called if the mesh changed.

Implements irr::scene::IMeshBuffer.

Definition at line 116 of file SSharedMeshBuffer.h.

References BoundingBox, Indices, and Vertices.

## setBoundingBox()

virtual void irr::scene::SSharedMeshBuffer::setBoundingBox | ( | const core::aabbox3df & | box | ) |

inline virtual

set user axis aligned bounding box

Implements irr::scene::IMeshBuffer.

Definition at line 104 of file SSharedMeshBuffer.h.

References BoundingBox.

## setDirty()

virtual void irr::scene::SSharedMeshBuffer::setDirty | ( | E_BUFFER_TYPE | buffer = EBT_VERTEX_AND_INDEX | ) |

inline virtual

flags the mesh as changed, reloads hardware buffers

Implements irr::scene::IMeshBuffer.

Definition at line 198 of file SSharedMeshBuffer.h.

References ChangedID_Index, ChangedID_Vertex, irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, and irr::scene::EBT_VERTEX_AND_INDEX.

## setHardwareMappingHint()

virtual void irr::scene::SSharedMeshBuffer::setHardwareMappingHint | ( | E_HARDWARE_MAPPING | NewMappingHint,
|  | E_BUFFER_TYPE | buffer = EBT_VERTEX_AND_INDEX )

inline virtual

set the hardware mapping hint, for driver

Implements irr::scene::IMeshBuffer.

Definition at line 189 of file SSharedMeshBuffer.h.

References irr::scene::EBT_INDEX, irr::scene::EBT_VERTEX, irr::scene::EBT_VERTEX_AND_INDEX, MappingHintIndex, and MappingHintVertex.

## Member Data Documentation

## BoundingBox

core::aabbox3df irr::scene::SSharedMeshBuffer::BoundingBox

Bounding box.

Definition at line 230 of file SSharedMeshBuffer.h.

Referenced by getBoundingBox(), recalculateBoundingBox(), and setBoundingBox().

## ChangedID_Index

u32 irr::scene::SSharedMeshBuffer::ChangedID_Index

ID used for hardware buffer management.

Definition at line 227 of file SSharedMeshBuffer.h.

Referenced by SSharedMeshBuffer(), getChangedID_Index(), and setDirty().

## ChangedID_Vertex

u32 irr::scene::SSharedMeshBuffer::ChangedID_Vertex

ID used for hardware buffer management.

Definition at line 224 of file SSharedMeshBuffer.h.

Referenced by SSharedMeshBuffer(), getChangedID_Vertex(), and setDirty().

## Indices

core::array<u16> irr::scene::SSharedMeshBuffer::Indices

Array of Indices.

Definition at line 221 of file SSharedMeshBuffer.h.

Referenced by getIndexCount(), getIndices(), getIndices(), getNormal(), getNormal(), getPosition(), getPosition(), getTCoords(), getTCoords(), and recalculateBoundingBox().

## MappingHintIndex

E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::MappingHintIndex

Definition at line 234 of file SSharedMeshBuffer.h.

Referenced by SSharedMeshBuffer(), getHardwareMappingHint_Index(), and setHardwareMappingHint().

## MappingHintVertex

E_HARDWARE_MAPPING irr::scene::SSharedMeshBuffer::MappingHintVertex

hardware mapping hint

Definition at line 233 of file SSharedMeshBuffer.h.

Referenced by SSharedMeshBuffer(), getHardwareMappingHint_Vertex(), and setHardwareMappingHint().

## Material

video::SMaterial irr::scene::SSharedMeshBuffer::Material

Material of this meshBuffer.

Definition at line 215 of file SSharedMeshBuffer.h.

Referenced by getMaterial(), and getMaterial().

## Vertices

core::array<video::S3DVertex>* irr::scene::SSharedMeshBuffer::Vertices

Shared Array of vertices.

Definition at line 218 of file SSharedMeshBuffer.h.

Referenced by SSharedMeshBuffer(), SSharedMeshBuffer(), getNormal(), getNormal(), getPosition(), getPosition(), getTCoords(), getTCoords(), getVertexCount(), getVertices(), getVertices(), and recalculateBoundingBox().

The documentation for this struct was generated from the following file:

- SSharedMeshBuffer.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0